searchNodes=[{"doc":"Exdn is a two-way translator between Elixir data structures and data following the edn specification; it wraps the erldn edn parser for Erlang, with some changes in the data formats.Examplesiex&gt; Exdn.to_elixir! &quot;[1 :foo]&quot; [1, :foo] iex&gt; Exdn.to_elixir &quot;{1 :foo, 2 :bar}&quot; {:ok, %{1 =&gt; :foo, 2 =&gt; :bar}} iex&gt; Exdn.from_elixir! %{1 =&gt; :foo, 2 =&gt; :bar} &quot;{1 :foo 2 :bar}&quot; iex&gt; Exdn.from_elixir %{:foo =&gt; {:char, ?a}, {:char, ?b} =&gt; {:tag, :inst, &quot;1985-04-12T23:20:50.52Z&quot;} } {:ok, &quot;{:foo \\a \\b #inst &quot;1985-04-12T23:20:50.52Z&quot;}&quot; }Type mappings:ednElixir generated by to_elixir functions (when no custom converter is provided)integerintegerfloatfloatbooleanbooleannilnil (atom)charstringstringstringlisttagged list {:list, [...]}vectorlistmapmapsetmapsetsymboltagged atom {:symbol, atom}tagged elementscall registered handler for that tag, fail if not foundElixir accepted by from_elixir functionsednintegerintegerfloatfloatbooleanbooleannil (atom)niltagged integer {:char, &lt;integer&gt;}charstringstringtagged list {:list, [...]}listlistvectormapmapstructmapmapsetsettagged atom {:symbol, atom}symboltagged tuple with tag and value {:tag, Symbol, Value}tagged elements","ref":"Exdn.html","title":"Exdn","type":"module"},{"doc":"interprets a tagged expression using the tagged reversible representation and handlers passed in as a keyword list. Assumes the expression inside the tag has already been translated from edn.Example:iex&gt; tagged = {:tag, :foo, &quot;blarg&quot;} iex&gt; handler = fn(_tag, val, _converter, _handlers) -&gt; val &lt;&gt; &quot;-converted&quot; end iex&gt; Exdn.evaluate_tagged_expr(tagged, [{:foo, handler}] &quot;blarg-converted&quot;","ref":"Exdn.html#evaluate_tagged_expr/3","title":"Exdn.evaluate_tagged_expr/3","type":"function"},{"doc":"safe version of from_elixir!/1 -- the edn string is returned as the second element of a pair whose first element is :ok -- if there is an error the first element will be :error and the second the error that was raised.Example:iex&gt; Exdn.from_elixir %{:foo =&gt; {:char, ?a}, {:char, ?b} =&gt; {:tag, :inst, &quot;1985-04-12T23:20:50.52Z&quot;} } {:ok, &quot;{:foo \\a \\b #inst &quot;1985-04-12T23:20:50.52Z&quot;}&quot; }","ref":"Exdn.html#from_elixir/1","title":"Exdn.from_elixir/1","type":"function"},{"doc":"converts an Elixir data structure in the &quot;reversible&quot; format (see below) into an edn string. Will raise exceptions if the data structure cannot be converted.Examples:# The intermediate representation can be converted back to edn: iex&gt; Exdn.from_elixir! 41.2 &quot;41.2&quot; iex&gt; Exdn.from_elixir! :foo &quot;:foo&quot; iex&gt; Exdn.from_elixir! true &quot;true&quot; iex&gt; Exdn.from_elixir! nil &quot;nil&quot; iex&gt; Exdn.from_elixir! &quot;asd&quot; &quot;&quot;asd&quot;&quot; iex&gt; Exdn.from_elixir! {:char, ?a} &quot;\\a&quot; iex&gt; Exdn.from_elixir! {:symbol, :foo} &quot;foo&quot; iex&gt; Exdn.from_elixir! [1, :foo] &quot;[1 :foo]&quot; iex&gt; Exdn.from_elixir! {:list, [1, :foo]} &quot;(1 :foo)&quot; iex&gt; Exdn.from_elixir! MapSet.new([1, :foo]) &quot;\#{1 :foo}&quot; iex&gt; Exdn.from_elixir! %{1 =&gt; :foo, 2 =&gt; :bar} &quot;{1 :foo 2 :bar}&quot; iex&gt; Exdn.from_elixir! %SomeStruct{foo: 1, bar: 2} &quot;{:foo 1 :bar 2}&quot; iex&gt; Exdn.from_elixir! {:tag, :inst, &quot;1985-04-12T23:20:50.52Z&quot;} &quot;#inst &quot;1985-04-12T23:20:50.52Z&quot;&quot;","ref":"Exdn.html#from_elixir!/1","title":"Exdn.from_elixir!/1","type":"function"},{"doc":"handlers for standard edn tagged expressions #inst and #uuid. If you need to supply your own custom handlers for other tags, you may wish to append them to this list of handlers.","ref":"Exdn.html#standard_handlers/0","title":"Exdn.standard_handlers/0","type":"function"},{"doc":"extracts a char (as a string) from the tagged reversible representation.Example:iex&gt; Exdn.tagged_char_to_string {:char, ?a} &quot;a&quot;","ref":"Exdn.html#tagged_char_to_string/1","title":"Exdn.tagged_char_to_string/1","type":"function"},{"doc":"extracts a list from the tagged reversible representation; does not operate at all on the contents of the extracted list.Example:iex&gt; Exdn.tagged_list_to_list {:list, [:foo]} [:foo]","ref":"Exdn.html#tagged_list_to_list/1","title":"Exdn.tagged_list_to_list/1","type":"function"},{"doc":"parses an edn string into an Elixir data structure, but does not throw exceptions. The parse result is returned as the second element of a pair whose first element is :ok -- if there is an error the first element will be :error and the second the error that was raised.Examples:iex&gt; Exdn.to_elixir &quot;{1 :foo, 2 :bar}&quot; {:ok, %{1 =&gt; :foo, 2 =&gt; :bar}} iex&gt; Exdn.to_elixir &quot;{:foo, \\a, \\b #foo &quot;blarg&quot; }&quot; {:error, %RuntimeError{:message =&gt; &quot;Handler not found for tag foo with tagged expression blarg&quot;}}","ref":"Exdn.html#to_elixir/3","title":"Exdn.to_elixir/3","type":"function"},{"doc":"parses an edn string into an Elixir data structure; this is not a reversible conversion as chars are converted to strings, and tagged expressions are interpreted. This function can throw exceptions; for example, if a tagged expression cannot be interpreted. The second (optional) argument The third (optional) argument allows you to supply your own handlers for the interpretation of tagged expressions. These should be in the form of a keyword list. The first element of each pair should be a keyword corresponding to the tag, and the second element a function of three parameters (tag, value, handlers) that handles the tagged values. The one-argument version provides default handlers for #inst and #uuid.Examples:iex&gt; Exdn.to_elixir! &quot;41.2&quot; 41.2 iex&gt; Exdn.to_elixir! &quot;:foo&quot; :foo iex&gt; Exdn.to_elixir! &quot;true&quot; true iex&gt; Exdn.to_elixir! &quot;nil&quot; nil iex&gt; Exdn.to_elixir! &quot;&quot;asd&quot;&quot; &quot;asd&quot; # Char iex&gt; Exdn.to_elixir! &quot;\\a&quot; &quot;a&quot; # Symbol iex&gt; Exdn.to_elixir! &quot;foo&quot; {:symbol, :foo} # edn vectors become Elixir lists: iex&gt; Exdn.to_elixir! &quot;[1 :foo]&quot; [1, :foo] # edn lists are always tagged. Since Datomic is a principal use of edn, and since lists are # used in Datomic primarily for executable expressions rather than as data structures, we # use Elixir lists to represent vectors and keep edn lists specially tagged: iex&gt; Exdn.to_elixir! &quot;(1, :foo)&quot; {:list, [1, :foo]} # edn sets become Elixir sets: iex&gt; Exdn.to_elixir! &quot;\#{1 \\a 1}&quot; #MapSet&lt;[1, &quot;a&quot;]&gt; # Maps become Elixir maps: iex&gt; Exdn.to_elixir! &quot;{1 :foo, 2 :bar}&quot; %{1 =&gt; :foo, 2 =&gt; :bar} # You can also transform maps to Elixir structs by providing your own converter in the second argument: iex&gt; defmodule FooStruct do ...&gt; defstruct foo: &quot;default&quot; ...&gt; end iex&gt; converter = fn map -&gt; ...&gt; case map do ...&gt; %{:foo =&gt; _} -&gt; struct(FooStruct, map) ...&gt; anything_else -&gt; anything_else ...&gt; end ...&gt; end iex&gt; Exdn.to_elixir! &quot;{:foo 1, :bar 2}&quot;, converter %FooStruct{foo: 1} # Tagged expressions are converted. Standard converters for #inst and #uuid are included: iex&gt; Exdn.to_elixir! &quot;#inst &quot;1985-04-12T23:20:50.52Z&quot;&quot; %Calendar.DateTime{abbr: &quot;UTC&quot;, day: 12, hour: 23, min: 20, month: 4, sec: 50, std_off: 0, timezone: &quot;Etc/UTC&quot;, usec: 520000, utc_off: 0, year: 1985} iex&gt; Exdn.to_elixir! &quot;#uuid &quot;f81d4fae-7dec-11d0-a765-00a0c91e6bf6&quot;&quot; &quot;f81d4fae-7dec-11d0-a765-00a0c91e6bf6&quot; # You can provide your own handlers for tagged expressions: iex&gt; handler = fn(_tag, val, _handlers) -&gt; val &lt;&gt; &quot;-converted&quot; end iex&gt; Exdn.to_elixir! &quot;#foo &quot;blarg&quot;&quot;, [{:foo, handler}] &quot;blarg-converted&quot;","ref":"Exdn.html#to_elixir!/3","title":"Exdn.to_elixir!/3","type":"function"},{"doc":"parses an edn string into an Elixir data structure, but in a reversible way -- chars and tagged expressions are represented using tuples whose first element is :char or :tag, respectively.Examples:iex&gt; Exdn.to_reversible( &quot;\\a&quot; ) {:char, ?a} iex&gt; Exdn.to_reversible &quot;#inst &quot;1985-04-12T23:20:50.52Z&quot;&quot; {:tag, :inst, &quot;1985-04-12T23:20:50.52Z&quot;} # An unknown tag raises no error when using the reversible conversion: iex&gt; Exdn.to_reversible &quot;#foo &quot;blarg&quot;&quot; {:tag, :foo, &quot;blarg&quot;}","ref":"Exdn.html#to_reversible/1","title":"Exdn.to_reversible/1","type":"function"},{"doc":"","ref":"Exdn.html#t:converter/0","title":"Exdn.converter/0","type":"type"},{"doc":"","ref":"Exdn.html#t:exdn/0","title":"Exdn.exdn/0","type":"type"},{"doc":"","ref":"Exdn.html#t:handler/0","title":"Exdn.handler/0","type":"type"}]